unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    ScrollBar1: TScrollBar;
    Button3: TButton;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  cxMax,cyMax:Integer; // 

implementation

{$R *.DFM}

function sign (x:real):integer; // " "
begin
 if x>0 then sign:=1
 else if x<0 then sign:=-1
 else sign:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);// Redraw
var a,b,c,x,y,x0,y0,xmin,xmax,ymin,ymax:real; //    
    xCoef,yCoef:real; //    
    steps,i:LongInt; //    
    cx,cy,percent:integer; //   
    Color1:TColor; //
    BitMap1 : TBitMap; //  
begin
 cxMax:=Form1.Image1.Width;
 cyMax:=Form1.Image1.Height;
 Form1.Image1.SetBounds (0,0,cxMax,cyMax);
 BitMap1 := TBitMap.Create;
 Bitmap1.Width := cxMax;
 Bitmap1.Height := cyMax;
 Form1.Image1.Picture.Graphic := Bitmap1;
 Button3Click(Sender);
 // 
 try
  a:=StrToFloat (Edit1.Text);
  b:=StrToFloat (Edit2.Text);
  c:=StrToFloat (Edit3.Text);
 except
  on EConvertError do begin
   ShowMessage (', a,b,c       ');
   exit;
  end;
 end;
 steps:=ScrollBar1.Position;
 // 
 x0:=0;
 y0:=0;
 xmin:=1e38; xmax:=-1e38; ymin:=1e38; ymax:=-1e38;
 for i:=1 to steps do begin
  x:=y0-sign(x0)*sqrt(abs(b*x0-c));
  y:=a-x0;
  if x>xmax then xmax:=x
  else if x<xmin then xmin:=x;
  if y>ymax then ymax:=y
  else if y<ymin then ymin:=y;
  x0:=x; y0:=y;
  if i mod 100 = 0 then begin
   percent:=Round(i/(2*steps)*100);
   Form1.Caption:=IntToStr(percent)+'%';
  end;
 end;
 xCoef:=cxMax/(xmax-xmin);
 yCoef:=cyMax/(ymax-ymin);
 //  
 x0:=0;
 y0:=0;
 cx:=cxMax div 2;
 cy:=cyMax div 2;
 for i:=1 to steps do begin
  Color1:=Image1.Canvas.Pixels[cx,cy]+1000;
  Image1.Canvas.Pen.Color:=Color1;
  Image1.Canvas.Pixels[cx,cy]:=Color1;
  x:=y0-sign(x0)*sqrt(abs(b*x0-c));
  y:=a-x0;
  x0:=x; y0:=y;
  cx:=Round((x-xmin)*xCoef);
  cy:=Round((y-ymin)*yCoef);
  if i mod 100 = 0 then begin
   percent:=Round((i+steps)/(2*steps)*100);
   Form1.Caption:=IntToStr(percent)+'%';
  end;
 end;
 Form1.Caption:='Laces';
 Bitmap1.Free;
end;

procedure TForm1.Button2Click(Sender: TObject); // Save
var sf:string;
begin
 if SaveDialog1.Execute then begin
  sf:=ChangeFileExt(SaveDialog1.FileName, '.bmp');
  if Length(sf)=4 then sf:='superbubs.bmp';
  if FileExists(sf) then
   if MessageDlg('    ' + ExtractFileName(sf) + '?',
     mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
  try
   Image1.Picture.SaveToFile(sf);
  except
   on EFOpenError do begin
    ShowMessage ('   '+sf+'  .     .');
    exit;
   end;
  end;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin   //     
 Edit1.Text:=FloatToStrF(1.5,ffFixed,7,1);
 Edit2.Text:=FloatToStrF(1.5,ffFixed,7,1);
 Edit3.Text:=FloatToStrF(1.5,ffFixed,7,1);
 FormResize(Sender);
 Button3Click(Sender);
 ScrollBar1Change(Sender);
end;

procedure TForm1.FormResize(Sender: TObject);
begin //      
  //        Redraw
 Label5.Caption:=IntToStr(Image1.Width)+'x'+IntToStr(Image1.Height);
end;

procedure TForm1.Button3Click(Sender: TObject); // Clear
begin
 Image1.Canvas.Brush.Color:=clBlack;
 Image1.Canvas.FillRect(Rect(0,0,cxMax,cyMax));
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin //   
 Label4.Caption:=IntToStr(ScrollBar1.Position);
end;

end.
